LeetCode-Combination Sum

来源:互联网 发布:华为手机端口怎么查 编辑:程序博客网 时间:2024/06/06 08:55

题目:https://oj.leetcode.com/problems/combination-sum/

Given a set of candidate numbers (C) and a target number (T), find all unique combinations in C where the candidate numbers sums to T.

The same repeated number may be chosen from C unlimited number of times.

Note:

  • All numbers (including target) will be positive integers.
  • Elements in a combination (a1a2, … , ak) must be in non-descending order. (ie, a1 ≤ a2 ≤ … ≤ ak).
  • The solution set must not contain duplicate combinations.

For example, given candidate set 2,3,6,7 and target 7
A solution set is: 
[7] 
[2, 2, 3] 

源码:Java版本
算法分析:时间复杂度O(n!),空间复杂度O(n)

public class Solution {   public List<List<Integer>> combinationSum(int[] candidates,int target) {if (candidates == null) {return null;}Set<List<Integer>> results = new HashSet<List<Integer>>();Stack<Integer> stack = new Stack<Integer>();Arrays.sort(candidates);DFS(candidates,0, target, stack, results);return new ArrayList<List<Integer>>(results);}@SuppressWarnings("unchecked")private void DFS(int[] candidates,int start, int target, Stack<Integer> stack,Set<List<Integer>> results) {if (target == 0) {results.add((Stack<Integer>) (stack.clone()));}for (int i = start; i < candidates.length; i++) {stack.push(candidates[i]);if (target - candidates[i] >= 0) {DFS(candidates, i,target - candidates[i], stack, results);}stack.pop();}}    }
代码解释:

 1. 因为要升序,所有先对数组进行排序;

 2. 因为要升序,所以下次遍历的开始位置是当前位置,所以添加了start变量;

 3. 结果要无重复,故先用set收集结果去重。  

0 0
原创粉丝点击